package witersen.dao;

import java.util.List;
import witersen.dbc.DatabaseConnection;

import witersen.vo.Emp;

public class EmpDAOProxy implements IEmpDAO {
    private DatabaseConnection dbc = null;
    private IEmpDAO dao = null;

    public EmpDAOProxy() throws Exception {
        this.dbc = new DatabaseConnection();
        this.dao = new EmpDAOImpl(this.dbc.getConnection());
    }

    @Override
    public boolean doCreate(Emp emp) throws Exception {
        boolean flag = false;
        try {
            if (this.dao.findById(emp.getEmpno()) == null) {
                flag = this.dao.doCreate(emp);
            }
        } catch (Exception e) {
            throw e;
        } finally {
            this.dbc.close();
        }
        return flag;
    }

    @Override
    public Emp findById(int empno) throws Exception {
        Emp emp = null;
        try {
            emp = this.dao.findById(empno);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            this.dbc.close();
        }
        return emp;
    }

    @Override
    public List<Emp> findAll(String keyWord, int pageSize, int current) throws Exception {
        List<Emp> all = null;
        try {
            all = this.dao.findAll(keyWord, pageSize, current);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            this.dbc.close();
        }
        return all;
    }

    @Override
    public int getTotalCount(String keyWord) throws Exception {
        int total = 0;
        try {
            total = this.dao.getTotalCount(keyWord);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            this.dbc.close();
        }
        return total;
    }

    @Override
    public boolean updateInfo(Emp emp) throws Exception {
        boolean flag = false;
        try {
            if (this.dao.findById(emp.getEmpno()) != null) {
                flag = this.dao.updateInfo(emp);
            }
        } catch (Exception e) {
            throw e;
        } finally {
            this.dbc.close();
        }
        return flag;
    }

}
