package witersen.dao;

import java.util.List;

import witersen.vo.Emp;

public interface IEmpDAO {
    // 数据的增加操作 emp表示要增加的数据对象
    public boolean doCreate(Emp emp) throws Exception;

    // 数据的查询操作
    public List<Emp> findAll(String keyWord, int pageSize, int current) throws Exception;

    // 根据编号查询信息 empno为雇员编号
    public Emp findById(int empno) throws Exception;

    // 获取数据总条数
    public int getTotalCount(String keyWord) throws Exception;
    
    // 根据雇员编号修改雇员信息
    public boolean updateInfo(Emp emp) throws Exception;
}
